package com.scm.contract.dao.print;

import com.scm.contract.model.print.PrintCode;
import com.scm.contract.model.print.SerialNumberRange;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * @author zuo
 * @date 2024/6/25 16:35
 */
@Mapper
public interface PrintCodeDao {
    List<PrintCode> getListByDetailIds(@Param("ids") List<String> ids);

    List<PrintCode> getListByDetailId(@Param("detailId") String detailId);

    Boolean saveList(@Param("printCodes") List<PrintCode> printCodes);

    List<PrintCode> getMaxSerialNumber();

    List<SerialNumberRange> getSerialNumberRange(@Param("ids") List<String> ids);

    int updateIsDeliverGoods(@Param("printCodeIds") List<String> printCodeIds,
                             @Param("isDeliverGoods") Integer isDeliverGoods);


    List<PrintCode> getListByIds(@Param("printCodeIds") List<String> printCodeIds);

    int updateBash(@Param("printCodes") List<PrintCode> printCodes);

    List<PrintCode> getListByEpcs(@Param("epcs") List<String> epcs);
}
