package com.scm.contract.model.management;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.set.direwolf.core.mybatis.BaseEntity;
import lombok.Data;

import java.util.Date;
import java.util.List;

/**
 * 供应商信息
 *
 * @author zuo
 * @date 2024/6/7 10:44
 */

@Data
public class Provider extends BaseEntity<Provider, String> {

    private static final long serialVersionUID = 1L;

    /**
     * id
     */
    @TableId
    private String id;

    /**
     * 供应商名称
     */
    @TableField(value = "`name`")
    private String name;

    /**
     * 供应商编码
     */
    @TableField(value = "`code`")
    private String code;

    /**
     * 供应商缩写
     */
    @TableField(value = "`abbr`")
    private String abbr;

    /**
     * 联系人
     */
    @TableField(value = "`liaison`")
    private String liaison;


    /**
     * 联系电话
     */
    @TableField(value = "`phone`")
    private Long phone;

    /**
     * 邮箱
     */
    @TableField(value = "`mail`")
    private String mail;

    /**
     * 地址
     */
    @TableField(value = "`address`")
    private String address;

    /**
     * 创建时间
     */
    @JsonFormat(timezone = "GMT+8", pattern = "yyyy/MM/dd HH:mm:ss")
    @TableField(value = "`createTime`")
    private Date createTime;

    /**
     * 修改时间
     */
    @JsonFormat(timezone = "GMT+8", pattern = "yyyy/MM/dd HH:mm:ss")
    @TableField(value = "`updateTime`")
    private Date updateTime;

    @TableField(exist = false)
    private List<List<String>> order;

    public Provider() {
    }

    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getCode() {
        return code;
    }

    public void setCode(String code) {
        this.code = code;
    }

    public String getAbbr() {
        return abbr;
    }

    public void setAbbr(String abbr) {
        this.abbr = abbr;
    }

    public String getLiaison() {
        return liaison;
    }

    public void setLiaison(String liaison) {
        this.liaison = liaison;
    }

    public Long getPhone() {
        return phone;
    }

    public void setPhone(Long phone) {
        this.phone = phone;
    }

    public String getMail() {
        return mail;
    }

    public void setMail(String mail) {
        this.mail = mail;
    }

    public String getAddress() {
        return address;
    }

    public void setAddress(String address) {
        this.address = address;
    }

    public Date getCreateTime() {
        return createTime;
    }

    public void setCreateTime(Date createTime) {
        this.createTime = createTime;
    }

    public Date getUpdateTime() {
        return updateTime;
    }

    public void setUpdateTime(Date updateTime) {
        this.updateTime = updateTime;
    }

    public List<List<String>> getOrder() {
        return order;
    }

    public void setOrder(List<List<String>> order) {
        this.order = order;
    }
}
