package com.scm.contract.model.message;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.set.direwolf.core.mybatis.BaseEntity;
import lombok.Data;

import java.util.Date;
import java.util.List;

/**
 * @author zuo
 * @date 2024/6/17 12:16
 */
@Data
public class MessageCenter extends BaseEntity<MessageCenter, String> {

    private static final long serialVersionUID = 1L;

    /**
     * id
     */
    @TableId
    private String id;

    /**
     * 消息时间
     */
    @TableField(value = "`dataTime`")
    @JsonFormat(timezone = "GMT+8", pattern = "yyyy/MM/dd HH:mm:ss")
    private Date dataTime;

    /**
     * 标签类别id
     */
    @TableField(value = "`tagTypeId`")
    private String tagTypeId;

    /**
     * 是否告警
     */
    @TableField(value = "`isAlarm`")
    private Boolean isAlarm;

    /**
     * 消息内容
     */
    @TableField(exist = false)
    private String content;

    @TableField(exist = false)
    private List<List<String>> order;

    @JsonFormat(timezone = "GMT+8", pattern = "yyyy/MM/dd HH:mm:ss")
    @TableField(exist = false)
    private Date beginTime;

    @JsonFormat(timezone = "GMT+8", pattern = "yyyy/MM/dd HH:mm:ss")
    @TableField(exist = false)
    private Date endTime;

    public MessageCenter() {
    }

    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    public Date getDataTime() {
        return dataTime;
    }

    public void setDataTime(Date dataTime) {
        this.dataTime = dataTime;
    }

    public String getContent() {
        return content;
    }

    public void setContent(String content) {
        this.content = content;
    }

    public List<List<String>> getOrder() {
        return order;
    }

    public void setOrder(List<List<String>> order) {
        this.order = order;
    }

    public Date getBeginTime() {
        return beginTime;
    }

    public void setBeginTime(Date beginTime) {
        this.beginTime = beginTime;
    }

    public Date getEndTime() {
        return endTime;
    }

    public void setEndTime(Date endTime) {
        this.endTime = endTime;
    }
}
