package com.scm.contract.web.statistics;

import com.scm.contract.service.management.TagDataService;
import com.set.direwolf.core.web.OperationResult;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;

/**
 * @author zuo
 * @date 2024/7/25 9:00
 */
@Controller
@RequestMapping("${adminPath}/statistics")
public class StatisticsController {

    private final TagDataService tagDataService;

    @Autowired
    public StatisticsController(TagDataService tagDataService) {
        this.tagDataService = tagDataService;
    }

    /**
     * 获取标当前签数据情况
     *
     * @return 按照不同的标签类型，分别汇总显示总的采购数量，发放数量，锁定数量，作废数量，使用数量，和当前可用标签数量。按照不同的标签类型，分别汇总显示总的采购数量，发放数量，锁定数量，作废数量，使用数量，和当前可用标签数量。
     */
    @PostMapping("/tag/situation/list")
    public @ResponseBody OperationResult getTagSituation() {
        return OperationResult.buildSuccessResult("获取标签数据信息成功", tagDataService.getTagSituation());
    }
}
